<?php
///////////////////////////////////////////////////////////////////////////
require_once 'lib/abstract_preloaded_regular_screen.php';
require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class LinuxtvSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';
    const VERSION = ' [Linux IPTV]';
    private $session;
    private $account;
    private $pcode = null;
	const EPG_FONTSIZE_DEF_VALUE	= 'normal';//igores
	private	$epg_font_size;//igores
	private $page_num = 1;
    ///////////////////////////////////////////////////////////////////////

    public function __construct($session)
    {
        parent::__construct(self::ID);

        $this->session = $session;
        #$this->tv = $tv;
    }
	///////////////////////////record///////////////////////////////////////////
	public function do_get_ip_path_smb_defs(&$plugin_cookies)
    {
        $smb_user = isset($plugin_cookies->smb_user) ? 
		$plugin_cookies->smb_user : 'guest';
		$smb_pass = isset($plugin_cookies->smb_pass) ? 
		$plugin_cookies->smb_pass : 'guest';
		$ip_path = isset($plugin_cookies->ip_path) ? 
		$plugin_cookies->ip_path : '';
		$defs = array();
		
		$this->add_text_field($defs,
                    'ip_path',
                   'Путь к SMB папке(IP/имя папки/..)',
                    $ip_path, 0, 0, 0, 1, 750, 0, 0
            );
        $this->add_text_field($defs,
                    'smb_user',
                    'Имя пользователя SMB папки:',
                    $smb_user, 0, 0, 0, 1, 750, 0, 0
            );

		$this->add_text_field($defs,
                    'smb_pass',
                    'Пароль SMB папки:',
                    $smb_pass, 0, 1, 0, 1, 750, 0, 0
            );
        
        $this->add_close_dialog_and_apply_button($defs,
            'ip_path_smb_apply', 'ОК', 250);
        $this->add_close_dialog_button($defs,
            'Отмена', 250);
 
        return $defs;
    }
	public function do_get_recdata_path_smb_defs(&$plugin_cookies)
    {
        $recdata_smb_user = isset($plugin_cookies->recdata_smb_user) ? 
		$plugin_cookies->recdata_smb_user : 'guest';
		$recdata_smb_pass = isset($plugin_cookies->recdata_smb_pass) ? 
		$plugin_cookies->recdata_smb_pass : 'guest';
		$recdata_ip_path = isset($plugin_cookies->recdata_ip_path) ? 
		$plugin_cookies->recdata_ip_path : '';
		$defs = array();
		
		$this->add_text_field($defs,
                    'recdata_ip_path',
                   'Путь к SMB папке(IP/имя папки/..)',
                    $recdata_ip_path, 0, 0, 0, 1, 750, 0, 0
            );
        $this->add_text_field($defs,
                    'recdata_smb_user',
                    'Имя пользователя SMB папки:',
                    $recdata_smb_user, 0, 0, 0, 1, 750, 0, 0
            );

		$this->add_text_field($defs,
                    'recdata_smb_pass',
                    'Пароль SMB папки:',
                    $recdata_smb_pass, 0, 1, 0, 1, 750, 0, 0
            );
        
        $this->add_close_dialog_and_apply_button($defs,
            'recdata_path_smb_apply', 'ОК', 250);
        $this->add_close_dialog_button($defs,
            'Отмена', 250);
 
        return $defs;
    }
	///////////////////////////////////////////////////////////////////////////
    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();
		///////////////////////////////////////////////////////////////////
		$epg_font_size = isset($plugin_cookies->epg_font_size) ? $plugin_cookies->epg_font_size : self::EPG_FONTSIZE_DEF_VALUE;///igores
		$group_tv = isset($plugin_cookies->group_tv) ?
        $plugin_cookies->group_tv : '1';
		$show_hd = isset($plugin_cookies->show_hd) ?
        $plugin_cookies->show_hd : 'no';
		////////////////////////record////////////////////////////////////////////
		$recdata = isset($plugin_cookies->recdata) ? 
		$plugin_cookies->recdata : '/D';
		$recdata_dir = isset($plugin_cookies->recdata_dir) ? 
		$plugin_cookies->recdata_dir : '/';
		////////////////////////////////////////////////////////////////////////
        $plugin_dir = DuneSystem::$properties['install_dir_path'];
        $xml = simplexml_load_file($plugin_dir . '/dune_plugin.xml');
        $this->add_label($defs,'Плагин Linux IPTV:', 'Версия плагина: ' . VERSION_MAJOR . '.' . VERSION_MINOR . '.' . VERSION_SUBMINOR . ' [' . VERSION_DATE . ']');

        $user_name = isset($plugin_cookies->user_name) ? $plugin_cookies->user_name : '';
        $logged_in = $this->session->is_logged_in();
		$show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';
		////////////////////////////
		if ($this->page_num == 1)
		{
		
		//////////////////////////
        $unset = '<нет>';
        if ($logged_in)
        {
            $account_info = $this->session->get_account_info();
            if (empty($account_info))
            {
                $this->session->api_get_account_info();
                $account_info = $this->session->get_account_info();
            }
            $subscription = $account_info->subscriptions;

            $settings = $this->session->get_settings();
            if (empty($settings))
            {
                $this->session->api_get_settings();
                $settings = $this->session->get_settings();
            }
	    if ($this->session->get_quality() === null)
	        $this->session->api_get_quality();
			
        }
        else
            $subscription = null;

        $login_error = $this->session->get_login_error();


        if ($user_name == '')
            $login_str = $unset;
        else if (!$logged_in && !empty($login_error))
            $login_str = $login_error;
        else if (!$logged_in || !isset($account_info) || !isset($account_info->title))
            $login_str = $user_name;
        else
            $login_str = $user_name . ' (' .  HD::shortText($account_info->title,13) . ')';

        if (empty($subscription->end_date))
            $end_date = $unset;
        else
            $end_date = strval($subscription->end_date);
            
	$this->add_button
        (
            $defs,
            'abonement',
            "Абонемент для $login_str:",
            'Подробнее',
            700
        );
        #$this->add_label($defs, 'Абонемент:', $login_str);
        #$this->add_label($defs, 'Истекает:', $end_date);


        $this->add_button($defs, 'edit_subscription', 'Изменить пользователя:', 'Ввести подписку...', 700);

        if (!$logged_in)
            return $defs;

    //    $this->add_vgap($defs, 40);

        $show_tv = isset($plugin_cookies->show_tv) ?
            $plugin_cookies->show_tv : 'yes';
        $show_vod = isset($plugin_cookies->show_vod) ?
            $plugin_cookies->show_vod : 'yes';
            
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;

        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';
		
		

        $this->add_combobox($defs,
            'show_tv', 'Показывать TV в главном меню:',
            $show_tv, $show_ops, 700, true);

        $show_buf_time_ops = array();

        $show_buf_time_ops[0] = 'По умолчанию';
        $show_buf_time_ops[500] = '0.5 с';
        $show_buf_time_ops[1000] = '1 с';
        $show_buf_time_ops[2000] = '2 с';
        $show_buf_time_ops[3000] = '3 с';
        $show_buf_time_ops[5000] = '5 с';
        $show_buf_time_ops[10000] = '10 с';
        $show_buf_time_ops[15000] = '15 с';
        $show_buf_time_ops[20000] = '20 с';

        $this->add_combobox
        (
            $defs,
            'buf_time',
            'Время буферизации:',
            $buf_time, $show_buf_time_ops, 700, true
        );

        $stream_server_ops = array();
        $stream_server = intval($settings->media_server_id);
        foreach ($settings->media_servers->item as $pair)
            $stream_server_ops[intval($pair->id)] = strval($pair->title);
        $this->add_combobox($defs,
            'media_server_id', 'Сервер вещания:',
            $stream_server, $stream_server_ops, 700, true);

		$quality_ops = array();
		////////////////
		$quality_ops['lq'] = 'Низкое';
        $quality_ops['mq'] = 'Среднее (по умолчанию)';
        #$quality_ops['hq'] = 'Высокое';
		///////////////
		$quality = isset($plugin_cookies->quality) ? $plugin_cookies->quality : 'mq';
        $this->add_combobox($defs,
            'quality_id', 'Качество трансляции:',
            $quality, $quality_ops, 700, true);
		
        $this->pcode = strval($settings->parental_pass);
        hd_print("Current pcode: $this->pcode");

        $this->add_button($defs, 'edit_pcode', 'Родительский контроль:',
            'Изменить...', 700);
		$this->add_button
            (
                $defs,
                'page2',
                '',
                'Настройки далее ==>',
                700
            );
		}
	else if ($this->page_num == 2)
		{
        
		$this->add_button
            (
                $defs,
                'page1',
                'Настройки страница 2 из 2             ',
                '<== На первую страницу настроек',
                700
            );
		//////////////////////////epg igores//////////////////////////////////////
			$epg_font_size_ops = array();
			$epg_font_size_ops ['normal'] = 'Обычный';
			$epg_font_size_ops ['small'] = 'Мелкий';
			$this->add_combobox($defs,
				'epg_font_size', 'Размер шрифта EPG:', 
				$epg_font_size, $epg_font_size_ops, 700, true);
			//////////////////////////record/////////////////////////////////////
			$recdata_ops = array();
			$recdata_ops['/D'] = 'Первый HDD/USB-диск';
			$recdata_ops[1] = 'SMB папка';
			foreach (glob('/tmp/mnt/storage/*') as $file) 
				if (is_dir($file)) $recdata_ops[$file] = ' -'.substr($file,17,strlen($file));
		/////////////////////////////////////////////////////////////////////
			$this->add_combobox($defs,
            'recdata', 'Сохранять записи в:',
            $recdata, $recdata_ops, 0, true);		
			if ($recdata !== '1') {
				$recdata_dir_ops = array();
				$recdata_dir_ops["$recdata"] = '/';
				foreach (glob("$recdata/*") as $file)
				if (is_dir($file)) {
				if (preg_match('|/tmp/mnt/|', $file))
					$file	= basename($file);
				else
					$file	= substr($file,3,strlen($file));
				$recdata_dir_ops['/'.$file.'/'] = $file;
				}
				$this->add_combobox($defs,
						'recdata_dir', 'Каталог:',
						$recdata_dir, $recdata_dir_ops, 0, true);
			}	
			elseif ($recdata == '1') {
				 $this->add_button($defs,
					'recdata_path_smb',
					'Путь, логин и пароль SMB:',
					'Изменить',
					500
				);	
			}
			////////////////////////////////////////////////////////////////
			$this->add_button
            (
                $defs,
                'restart',
                '',
                'Перезагрузить плагин',
                0
            );
		}
        return $defs;
    }
	
    private function do_get_edit_pcode_defs()
    {
        $defs = array();

        $this->add_text_field($defs,
            'current_pcode', 'Текущий код доступа:',
            '', true, true, false, false, 400);

        $this->add_text_field($defs,
            'new_pcode', 'Новый код:',
            $this->pcode, true, true, false, false, 400);

        $this->add_text_field($defs,
            'new_pcode_copy', 'Подтвердить новый код:',
            $this->pcode, true, true, false, false, 400);

        $this->add_vgap($defs, 50);

        $this->add_button($defs,
            'apply_pcode', null, 'Сменить', 300);

        $this->add_vgap($defs, -3);

        $this->add_close_dialog_button($defs,
            'Отмена', 300);

        return $defs;
    }

    private function do_get_edit_pcode_action()
    {
        return ActionFactory::show_dialog(
            'Родительский контроль',
            $this->do_get_edit_pcode_defs(),
            true);
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        #hd_print("Setup::get_control_defs");
        foreach($media_url as $key => $val)
            #hd_print("  MediaURL: $key => $val");

        try
        {
            if (!$this->session->is_login_incorrect())
                $this->session->ensure_logged_in($plugin_cookies, false);
        }
        catch (Exception $e)
        {
        }
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Setup: handle_user_input:');
        foreach ($user_input as $key => $value)
            #hd_print("  $key => $value");

        $need_close_dialog = false;
        $need_reset_controls = false;
    //    $post_action = null;
        $control_id = $user_input->control_id;

        if (isset($user_input->{$control_id}))
        {
            $new_value = $user_input->{$control_id};
            #hd_print("Setup: changing $control_id value to $new_value");
        }
        else
            $new_value = null;
		hd_silence_warnings();
        if ($user_input->action_type === 'confirm' || $user_input->action_type === 'apply')
        {
            if ($control_id === 'show_tv')
                $plugin_cookies->show_tv = $new_value;
			if ($control_id === 'group_tv'){
				$need_reset_controls = true;
				$plugin_cookies->group_tv = $new_value;
				$perform_new_action = UserInputHandlerRegistry::create_action(
                    $this, 'reset_controls');
				return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
				}
			if ($control_id === 'show_hd'){
				$need_reset_controls = true;
                $plugin_cookies->show_hd = $new_value;
				$perform_new_action = UserInputHandlerRegistry::create_action(
                    $this, 'reset_controls');
				return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
				}
            else if ($control_id === 'show_vod')
                $plugin_cookies->show_vod = $new_value;
            else if ($control_id === 'buf_time')
                $plugin_cookies->buf_time = $new_value;
			else if ($control_id === 'abonement')
            {
				$account = $this->session->api_get_account_info();
                                $this->account = $account;
				
				$post_action = null;
				
				$text = '  Договор: ' . $account->title;
				$text_0 = '  Nr. договора: ' . $account->id;
				$text_0_1 = '  На счету: ' . $account->balance;
				#$text_3 = '  Начало: ' . $end_date;
				$defs = array();
				
				ControlFactory::add_img_label($defs, '', "<icon>". DuneSystem::$properties['install_dir_path']."/icons/special/dogovor.png</icon><text dy='7' size='normal'>$text</text>", 0, 0, 0);
				ControlFactory::add_img_label($defs, '', "<icon>". DuneSystem::$properties['install_dir_path']."/icons/special/number.png</icon><text dy='7' size='normal'>$text_0</text>", 0, 0, 0);
				ControlFactory::add_img_label($defs, '', "<icon>". DuneSystem::$properties['install_dir_path']."/icons/special/cash.png</icon><text dy='7' size='normal'>$text_0_1</text>", 0, 0, 0);
				#if($this->account->services == false){
				#ControlFactory::add_img_label($defs, '', "<text dy='7' size='normal' color='21'>Подписка не активна!</text>", 0, 0, 0);
				#}
				if($account->subscriptions == true){
				$this->add_button($defs,'services',"",'    Ваш тарифный план',550);
				}
				ControlFactory::add_label($defs, "", '                                                                 ');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'setup', 'Ok', 150,  $post_action);

				return ActionFactory::show_dialog('Ваша подписка', $defs, true, 900);
            }
            else if ($control_id === 'services')
            {
            
            $i = 1;
            $n = count($this->account->subscriptions);
            foreach ($this->account->subscriptions as $services){          
            $plan = 'Услуга:          ' .$services->title 
             ."\n" .'Заканчивается:   ' . $this->reverse_date($services->end_date) ."\n";
             if($i < $n){
                $plan .= "_______________________________";
                ++$i;
               }
            $fill_plan .= (string)$plan ."\n\n";             
             }
                ControlFactory::add_multiline_label($defs, '', $fill_plan, 15);
                ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'setup', 'Ok', 150,  $post_action);

			return ActionFactory::show_dialog('Ваш тарифный план', $defs,true,900);            
            }
            else if ($control_id == 'media_server_id')
            {
                try
                {
                    $this->session->api_set_setting($control_id, $new_value);
                }
                catch (DuneException $e)
                {
                    return $e->get_error_action();
                }
            }
			else if ($control_id == "quality_id")
			{
				$plugin_cookies->quality = $new_value;
			}
			///////////////////////////////////////////////////
			else if ($control_id == 'epg_font_size')
			{
				$plugin_cookies->epg_font_size = $new_value;
			}
			//////////////////////////////////////////////////
           else if ($control_id === 'edit_subscription')
            {
                return $this->session->do_get_edit_subscription_action(
                    $plugin_cookies, $this);
            }
            else if ($control_id === 'apply_subscription')
            {
                if ($user_input->user_name === '')
                {
                    return ActionFactory::show_error(false,
                        'Error',
                        array('Subscription should be non-empty.'));
                }

                $plugin_cookies->user_name = $user_input->user_name;
                $plugin_cookies->password = $user_input->password;

                $this->session->logout();

                try
                {
                    $this->session->try_login($plugin_cookies, false);
                }
                catch (DuneException $e)
                {
                    $post_action = $e->get_error_action();
                    return $post_action;
                }
                $need_close_dialog = true;
                $need_reset_controls = true;
            }
            else if ($control_id === 'edit_pcode')
            {
                return $this->do_get_edit_pcode_action();
            }
            else if ($control_id === 'apply_pcode')
            {
                if ($user_input->new_pcode != $user_input->new_pcode_copy)
                    return ActionFactory::show_error(false, 'Error', array('Подтвердите новый код.'));
                if ($user_input->new_pcode == '')
                    return ActionFactory::show_error(false, 'Error', array('Введите новый код.'));
                try
                {
                    $this->session->api_change_pcode(
                        $user_input->current_pcode,
                        $user_input->new_pcode);
                    $this->session->api_get_settings();
                }
                catch (DuneException $e)
                {
                    return $e->get_error_action();
                }
                $need_close_dialog = true;
                $need_reset_controls = true;
            }
			else if ($control_id === 'page1')
            {
				$need_reset_controls = true;
                $this->page_num = 1;
                return ActionFactory::reset_controls(
                    $this->do_get_control_defs($plugin_cookies), null, 1);
            }
			else if ($control_id === 'page2')
            {
				$need_reset_controls = true;
                $this->page_num = 2;
                return ActionFactory::reset_controls(
                    $this->do_get_control_defs($plugin_cookies), null, 1);
            }
			///////////////////////////////record/////////////////////////////////////////
			else if ($control_id === 'recdata_dir')
			{
			$plugin_cookies->recdata_dir = $user_input->recdata_dir;
			$perform_new_action = UserInputHandlerRegistry::create_action(
            $this, 'reset_controls');
				return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
			}
			else if ($control_id === 'recdata')
			{
			$plugin_cookies->recdata = $user_input->recdata;
			$perform_new_action = UserInputHandlerRegistry::create_action(
            $this, 'reset_controls');
				return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
			}
			else if ($control_id === 'recdata_path_smb'){
				$defs = $this->do_get_recdata_path_smb_defs($plugin_cookies);
					
					return  ActionFactory::show_dialog
							(
								"Логин и пароль SMB папки",
								$defs,
								true
							);
				}
			else if ($control_id === 'recdata_path_smb_apply'){
				$plugin_cookies->recdata_smb_user = $user_input->recdata_smb_user;
				$plugin_cookies->recdata_smb_pass = $user_input->recdata_smb_pass;
				$plugin_cookies->recdata_ip_path = $user_input->recdata_ip_path;
				$perform_new_action = UserInputHandlerRegistry::create_action(
						$this, 'reset_controls');
			return ActionFactory::invalidate_folders(array('tv_group_list'), $perform_new_action);
			}
			else if ($control_id === 'ip_path_smb'){
				$defs = $this->do_get_ip_path_smb_defs($plugin_cookies);
					
					return  ActionFactory::show_dialog
							(
								"Логин и пароль SMB папки",
								$defs,
								true
							);
				}
			////////////////////////////////////////////////////////////////////////
			else if ($control_id === 'reset_controls')
				{
				return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies));
				}
			else if ($control_id === 'restart')
			{
                shell_exec('killall shell');
				 break;
			}
        }
        if ($need_reset_controls)
        {
            $defs = $this->do_get_control_defs($plugin_cookies);

            $reset_controls_action = ActionFactory::reset_controls(
                $defs, $post_action);

            if ($need_close_dialog)
            {
                return ActionFactory::close_dialog_and_run(
                    $reset_controls_action);
            }

            return $reset_controls_action;
        }
    //    return null;
        return ActionFactory::reset_controls(
           $this->do_get_control_defs($plugin_cookies));
		   hd_restore_warnings();
    }
	public function reverse_date($str)
	{
	$tmp = explode('-', $str);
	$str = $tmp[2] . '.' . $tmp[1] . '.' . $tmp[0];
	return $str;
	}

}

///////////////////////////////////////////////////////////////////////////
?>
