﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';
require_once 'lib/tv/epg_iterator.php';
require_once 'lib/user_input_handler_registry.php';

require_once 'linuxtv_channel.php';

///////////////////////////////////////////////////////////////////////////

class LinuxtvTv extends AbstractTv implements UserInputHandler
{
    private $session;
	public function get_handler_id() { return "tv"; }
    public function __construct($session)
    {
        $this->session = $session;
		
		UserInputHandlerRegistry::get_instance()->register_handler($this);
		
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            LinuxtvConfig::TV_FAVORITES_SUPPORTED,
            true);
    }

    public function get_fav_icon_url()
    {
        return LinuxtvConfig::FAV_CHANNEL_GROUP_ICON_PATH;
    }
	public function newload(&$plugin_cookies){
	hd_print('unload');
	if(is_null($this->channels) && is_null($this->groups)){
		$this->load_channels($plugin_cookies);
	}
    }
    ///////////////////////////////////////////////////////////////////////
	public function folder_entered(MediaURL $media_url, &$plugin_cookies) {
	if ($media_url->get_raw_string() == 'tv_group_list')
                $this->load_channels($plugin_cookies);            
    }
    ///////////////////////////////////////////////////////////////////////
    protected function ____load_channels(&$plugin_cookies)
    {
        if (!isset($plugin_cookies->login) || !isset($plugin_cookies->pass))
        {
               hd_print("Error: Authorization required!!!");
               return ;
        }
        try
        {
			
           $this->session->check_for_arch();
            $this->load_channels_($plugin_cookies);
        }
        catch (Exception $e)
        {
            hd_print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
        }

    }
	private function deleteItem( &$array, $value )
	{
		print_r($value);
		foreach( $array as $key => $val ){
			if( is_array($val) ){
				deleteItem($array[$key], $value);
			}elseif( $val===$value ){
				unset($array[$key]);
			}
		}
	}
    protected function load_channels(&$plugin_cookies)
    {
        $this->session->check_for_arch();
        $this->session->check_logged_in();
        
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		$hide_items = isset($plugin_cookies->hide_items) ? $plugin_cookies->hide_items : '';
		$hided_channels = isset($plugin_cookies->hided_channels) ? $plugin_cookies->hided_channels : 'no';
		$hided_categories = isset($plugin_cookies->hided_categories) ? $plugin_cookies->hided_categories : 'no';
		$hide_category_items = isset($plugin_cookies->hide_category_items) ? $plugin_cookies->hide_category_items : '';
		
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();
		#$this->global_channels = array();/////////new
		$xml = $this->session->api_get_groups_tv();
		#hd_print("category---------->$xml");
        if ($this->is_favorites_supported())
        {
            $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    LinuxtvConfig::FAV_CHANNEL_GROUP_CAPTION,
                    LinuxtvConfig::FAV_CHANNEL_GROUP_ICON_PATH));
        }

        $this->groups->put(
            new AllChannelsGroup(
                $this,
                LinuxtvConfig::ALL_CHANNEL_GROUP_CAPTION,
                LinuxtvConfig::ALL_CHANNEL_GROUP_ICON_PATH));
		
		/////////////////////////////////////////////////////////////////////////////////////////////////////
		$gal = explode('|', $hide_category_items);
		foreach ($xml->groups as $tv_category)//gruppen
        {

	if(!in_array(intval($tv_category->id), $gal)){
            $this->groups->put(
                new DefaultGroup(
                    strval($tv_category->id),
                    strval($tv_category->name),
                    LinuxtvConfig::TV_CHANNEL_GROUP_ICON_PATH . 'igores/' . strval($tv_category->id) . ".png"));
                    }

        }
		/////////////////////////////////////////////////////////////////////////////////////////////////////
        $xml_chan = $this->session->api_get_channels_tv();
        $chnum = 1;
        foreach ($xml_chan->channels->children() as $xml_tv_channel)
        {
            if ($xml_tv_channel->getName() !== 'item')
            {
                hd_print("Error: unexpected node '" . $xml_tv_channel->getName() .
                    "'. Expected: 'item'");
                throw new Exception('Invalid XML document');
            }


            $channel =
                new LinuxtvChannel(
                    intval($xml_tv_channel->id),
                    strval($xml_tv_channel->name),
                    $this->session->get_channel_icon(intval($xml_tv_channel->id)),
                    "",
                    $chnum,
                    14,
                    2,
                    $buf_time,
                    intval($xml_tv_channel->protected) == 1,
                    intval($xml_tv_channel->has_archive),
                    intval($xml_tv_channel->is_video));
					########hide########
					if($hided_channels == 'no')
					{
					$ch = strval($xml_tv_channel->id);
					$t = ListUtil::is_in_list($hide_items, $ch);
                    if ($ch == $t)
                   
						 continue;
					}
					####################
            $this->channels->put($channel);

	    $tv_category_id = intval($xml_tv_channel->group_id);
	    
	    if(!in_array(intval($tv_category_id), $gal)){
            $group = $this->groups->get($tv_category_id);
			
            #Link group and channel.
            $channel->add_group($group);
            $group->add_channel($channel);
			$chnum++;
			}
        }
		#remove empty groups
		$temp_groups = new HashedArray();
		foreach($this->get_groups() as $g)
			if($g->is_favorite_channels() or ($g->get_channels($plugin_cookies) != NULL and $g->get_channels($plugin_cookies)->size()))
				$temp_groups->put($g);
			else
				hd_print("Group " . $g->get_title() . " removed: no channels");
		$this->groups = $temp_groups;
	}
	//////////////////////////////NEW////////////////////////////////////
	private function get_linuxtv_dialog_action($n)
    {
        $params = array('n' => $n);
        return UserInputHandlerRegistry::create_action($this,
            'dialog', $params);
    }
	///////////////
	private function get_linuxtv_setup_dialog_action($n)
    {
        $params = array('n' => $n);
        return UserInputHandlerRegistry::create_action($this,
            'setup_dialog', $params);
    }
	//////////////
	private function get_linuxtv_reset_controls_action($n)
    {
        $params = array('n' => $n);
        return UserInputHandlerRegistry::create_action($this,
            'reset_controls', $params);
    }
	private function get_set_default_behaviour_action()
    {
        return ActionFactory::change_behaviour(
            array(
                GUI_EVENT_KEY_DUNE => $this->get_linuxtv_dialog_action(0),
				GUI_EVENT_KEY_SETUP => $this->get_linuxtv_setup_dialog_action(0),
            ));
    }
	private function get_sample_dialog_defs($n)
    {
        $defs = array();
		ControlFactory::add_label($defs, null,
            'Сделали: igores и micha86.');
			ControlFactory::add_label($defs, null,
            'Сайт: igores.ru/forum');
        ControlFactory::add_label($defs, null,
            'Подождите '.(10 - $n).' секунд или нажмите RETURN для закрытия...');
        return $defs;
    }

    private function get_sample_dialog_action($n)
    {
        return ActionFactory::show_dialog("Плагин для Дюны - Linux IPTV",
            $this->get_sample_dialog_defs($n),
            false, 0,
            array(
                'actions' => array(
                    GUI_EVENT_TIMER =>
                        $this->get_linuxtv_reset_controls_action($n + 1),
                    GUI_EVENT_KEY_RETURN => ActionFactory::close_dialog_and_run(
                        $this->get_set_default_behaviour_action()),
                ),
                'timer' => ActionFactory::timer(900),
                'dialog_params' => array('frame_style' => DIALOG_FRAME_STYLE_GLASS)));
    }
	/////////////////////////
	protected function add_close_dialog_and_apply_button(&$defs,
        $name, $caption, $width)
    {
        $params = array('button_caption_centered' => 1);
        ControlFactory::add_close_dialog_and_apply_button($defs,
            $this, null,
            $name, $caption, $width, $params);
    }

    protected function add_close_dialog_button(&$defs,
        $caption, $width)
    {
        $params = array('button_caption_centered' => 1);
        ControlFactory::add_close_dialog_button($defs,
            $caption, $width, $params);
    }
	private function get_setup_dialog_defs(&$plugin_cookies)
    {
        $defs = array();
		
		$settings = $this->session->get_settings();
		if (empty($settings))
            {
                $this->session->api_get_settings();
                $settings = $this->session->get_settings();
            }
			if ($this->session->get_quality() === null)
				$this->session->api_get_quality();
		$buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		$show_buf_time_ops = array();
        $show_buf_time_ops[0] = 'По умолчанию';
        $show_buf_time_ops[500] = '0.5 с';
        $show_buf_time_ops[1000] = '1 с';
        $show_buf_time_ops[2000] = '2 с';
        $show_buf_time_ops[3000] = '3 с';
        $show_buf_time_ops[5000] = '5 с';
        $show_buf_time_ops[10000] = '10 с';
        $show_buf_time_ops[15000] = '15 с';
        $show_buf_time_ops[20000] = '20 с';

        ControlFactory::add_combobox
        (
            $defs, $this, null,
            'buf_time',
            'Время буферизации:',
            $buf_time, $show_buf_time_ops, 600
        );
		
		$stream_server_ops = array();
        $stream_server = intval($settings->media_server_id);
        foreach ($settings->media_servers->item as $pair)
            $stream_server_ops[intval($pair->id)] = strval($pair->title);
        ControlFactory::add_combobox($defs, $this, null,
            'media_server_id', 'Сервер вещания:',
            $stream_server, $stream_server_ops, 600);

		$quality_ops = array();
		////////////////
		$quality_ops['lq'] = 'Низкое';
        $quality_ops['mq'] = 'Среднее (по умолчанию)';
        #$quality_ops['hq'] = 'Высокое';
		///////////////
		$quality = isset($plugin_cookies->quality) ? $plugin_cookies->quality : 'mq';
        ControlFactory::add_combobox($defs, $this, null,
            'quality_id', 'Качество трансляции:',
            $quality, $quality_ops, 600);
		//////////////////////////////////////////////
		$deit_ops = array();
		////////////////
		$deit_ops['off'] = 'Отключен';
        $deit_ops['bob'] = 'bob';
        $deit_ops['adaptive'] = 'Адаптивный';
		
		$deit = isset($plugin_cookies->deit) ? $plugin_cookies->deit : 'adaptive';
        ControlFactory::add_combobox($defs, $this, null,
            'deintrleis', 'Деинтерлейсинг:',
            $deit, $deit_ops, 600);
		//////////////////////////////////////////////
		$this->add_close_dialog_and_apply_button($defs,
            'setup_apply', 'Применить', 300);
        $this->add_close_dialog_button($defs,
            'Отмена', 300);
        return $defs;
    }
	////////////////////////
	
	public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('TV entry handler: handle_user_input:');
        foreach ($user_input as $key => $value)
            #hd_print("key--------> $key => value--------->$value");
		
		$control_id = $user_input->control_id;

        if (isset($user_input->{$control_id}))
        {
            $new_value = $user_input->{$control_id};
            hd_print("Setup: changing $control_id value to $new_value");
        }
        else
            $new_value = null;
        
        if ($user_input->control_id == 'dialog')
        {
            return $this->get_sample_dialog_action($user_input->n);
        }
		
		if ($user_input->control_id == 'setup_dialog')
        {
			return ActionFactory::show_dialog("Быстрые настройки",
            $this->get_setup_dialog_defs($plugin_cookies),
            true, 0,
            array('dialog_params' => array('frame_style' => DIALOG_FRAME_STYLE_GLASS)));
        }
		if ($user_input->action_type === 'apply')
        {
		$channel_id = $user_input->plugin_tv_channel_id;
		#	hd_print("channel_id -----------> $channel_id");
		$b_time = $user_input->buf_time;
            hd_print("Setup: changing buf_time value to $b_time");
		$media_s_id = $user_input->media_server_id;
            #hd_print("Setup: changing media_server_id value to $media_s_id");
		$q_id = $user_input->quality_id;
            #hd_print("Setup: changing quality_id value to $q_id");
        $plugin_cookies->buf_time = $b_time;
		////
		$d_inter = $user_input->deintrleis;
            #hd_print("Setup: changing buf_time value to $d_inter");
		$plugin_cookies->deit = $d_inter;
		///
        try
        {
            $this->session->api_set_setting("media_server_id", $media_s_id);
        }
        catch (DuneException $e)
        {
            return $e->get_error_action();
        }
		$plugin_cookies->quality = $q_id;
		
		$this->unload_channels();
		$this->newload($plugin_cookies);
		return ActionFactory::reset_controls(
			$this->get_setup_dialog_defs($plugin_cookies));
		}
        if ($user_input->control_id == 'reset_controls')
        {
            $close_action = ActionFactory::close_dialog_and_run(
                $this->get_set_default_behaviour_action());

            if ($user_input->n >= 9)
                $timer_action = $close_action;
            else
            {
                $timer_action = 
                    $this->get_linuxtv_reset_controls_action($user_input->n + 1);
            }

            return ActionFactory::reset_controls(
                $this->get_sample_dialog_defs($user_input->n),
                ActionFactory::change_behaviour(
                    array(
                        GUI_EVENT_TIMER => $timer_action,
                        GUI_EVENT_KEY_RETURN => $close_action,
                    ),
                    ActionFactory::timer(900)
                )
            );
        }
		
		return ActionFactory::reset_controls(
           $this->get_setup_dialog_defs($plugin_cookies));
        #return null;
    }
	/////////////////////////////////////////////////////////////////
    public function get_tv_info(MediaURL $media_url, &$plugin_cookies)
    {
        $this->session->ensure_logged_in($plugin_cookies);

        $info = parent::get_tv_info($media_url, &$plugin_cookies);

        $info[PluginTvInfo::actions] = array(

            GUI_EVENT_KEY_DUNE => $this->get_linuxtv_dialog_action(0),
			GUI_EVENT_KEY_SETUP => $this->get_linuxtv_setup_dialog_action(0),

        );
        return $info;
    }

///////////////////////////////////////////////////////////////////////////
    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
		$buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		$deit = isset($plugin_cookies->deit) ? $plugin_cookies->deit : 'adaptive';
        $this->ensure_channels_loaded($plugin_cookies);

        $cid = $this->get_channel($channel_id)->get_id();
        $cc = $this->get_channel($channel_id)->is_video();
        #hd_print("---> is_video: $cc, is_protected: " . $this->get_channel($channel_id)->is_protected());
        $this->session->check_for_arch();
        #TODO:2
		
		if($this->get_channel($channel_id)->is_protected() && $protect_code == '')
		{
			hd_print("No protect code supplied for protected channel");
			throw new DuneException(
					'No protect code supplied for protected channel', 99,
					ActionFactory::show_error(false, 'No protect code supplied for protected channel', array()));
		}
		
        //hd_print("channel:--->>> channel:$cid, archive:$archive_ts, protect:$protect_code");
		//////////////////////////////igores////////////////////////////////////
		if($cc == 0)
		{
			$xml = $this->session->get_url_radio($cid, $plugin_cookies);
			$tmp = str_ireplace('http://', 'http://audio_stream://', $xml->url);
		}
		//////////////////////////////////////////////////////////
        else
        {
            $xml = $this->session->api_get_url_tv($cid,$archive_ts,$protect_code, $plugin_cookies);
            if (intval($archive_ts) < 0)
            {
                $tmp = str_ireplace("http://", "http://ts://", $xml->url);
				$tmp .= "|||dune_params|||buffering_ms:$buf_time,deint_mode:$deit";
            }
            else
            {
                #$tmp = str_ireplace("http://", "http://ts://127.0.0.1:1000/cgi-bin/arch?http://", $xml->url);
				$tmp = $xml->url;
				$tmp .= "|||dune_params|||buffering_ms:$buf_time";
            }
        }
        #TODO:3
        $url = $tmp;
        hd_print("STREAM_URL:--->>>  $url");

        return $url;
    }

	////////////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    {
        $epg = array();

        $cc = $this->get_channel($channel_id)->is_video();
        if ($cc == 0)
        {
            $epg[] =
                new DefaultEpgItem(
                    "ТВ Программа отсутствует",
                    "",
                    "",
                    0);
        }
        else
        {
            $xml = $this->session->api_get_epg($day_start_ts, $channel_id);
            if ($xml->channels->item->getName() !== 'item')
            {
                $epg[] =
                    new DefaultEpgItem(
                        "ТВ Программа отсутствует",
                        "",
                        "",
                        0);
            }


            else
            {

                foreach ($xml->channels->item->epg->children() as $epg_item)
                {
                    if ($epg_item->getName() !== 'item')
                    {
                        hd_print("Error: unexpected node '" . $epg_item->getName() ."'. Expected: 'item'");
                        throw new Exception('Invalid XML document');
                    }
                    else
                    {
                        $epg[] =
                            new DefaultEpgItem(
                                strval($epg_item->title),
                                strval($epg_item->info),
                                intval($epg_item->begin),
								intval($epg_item->end));
                    }
                }
            }

        }
        return new EpgIterator(
            $epg,
            $day_start_ts,
            $day_start_ts + 86400 * 7);
    }
    ///////////////////////////////////////////////////////////////////////////
    // Hook for adding special group items.
    public function add_special_groups(&$items)
    {
        array_unshift($items,
            array
            (
                PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array
                    (
                        'screen_id' => LinuxtvVodRootScreen::ID,
                    )),
                PluginRegularFolderItem::caption => 'Видеотека',
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => 'plugin_file://icons/igores/videotheka.png'
                )
            ));
    }
	
    public function get_archive(MediaURL $media_url)
    { 
        return $this->session->get_archive(); 
    }
	
}
?>
