<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';

class LinuxtvVodRootScreen extends AbstractPreloadedRegularScreen
{
    const ID = 'vod_root';

    private $session;

    public function __construct($session, $folder_views)
    {
        parent::__construct(self::ID, $folder_views);

        $this->session = $session;
    }

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        return array
        (
            GUI_EVENT_KEY_ENTER => ActionFactory::open_folder(),
        );
    }

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
        $defs = array(
	    array(
                VodFavoritesScreen::get_media_url_str(),
                'Избранное', 'favorites_vod.png'),
	    array(
                LinuxtvVodListScreen::get_media_url_str('all'),
                'Все', 'all_films_vod.png'),
            array(
                LinuxtvVodListScreen::get_media_url_str('last'),
                'Новинки', 'new_films_vod.png'),
	    array(
                VodGenresScreen::get_media_url_str(),
                'Жанры', 'genres_vod.png'),
            array(
                VodYearsScreen::get_media_url_str(),
                'По Годам', 'years_vod.png'),    
	    array(
                LinuxtvVodListScreen::get_media_url_str('collections'),
                'Сборники', 'sammelung_vod.png'),
            array(
                LinuxtvVodListScreen::get_media_url_str('serials'),
                'Сериалы', 'serials_vod.png'),
            array(
                VodSearchScreen::get_media_url_str(),
                'Поиск', 'search_vod.png')
        );

        $items = array();

        foreach ($defs as $def)
        {
            $items[] = array
            (
                PluginRegularFolderItem::media_url => $def[0],
                PluginRegularFolderItem::caption => $def[1],
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path =>
                        $this->session->get_icon($def[2])
                )
            );
        }

        return $items;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
